#!python
import subprocess
import os
import sys
import re  # for regular expression
import shutil

# set relative path from top proj
proj_rel_dir = ""

# call definition file
common.Source("./def.py")

# path
src_abs_path = os.path.abspath(SRCDIR)

# call common file
common.Source(src_abs_path + "/arch/cx/common.py")

#
# convert map file
#
inputfile = open("./DefaultBuild/atk2-sc1.map")
outputfile = open("./DefaultBuild/atk2-sc1.syms", 'w')

r = re.compile("^\s+\d+\s+(0x[0-9a-f]+)\s+0x[0-9a-f]+\s+\w+\s+\w+\s+(\w+)")
line = inputfile.readline() 
while line:
    line = line.replace('\r\n','')   #delete newline
    m = r.search(line)
    if m:
        outputfile.write(m.group(1) + " T " + m.group(2) + "\n")
    line = inputfile.readline()

inputfile.close()
outputfile.close()

#
# copy pass 1 generated files
#
print "Copy pass 1 generated file"
shutil.copy("./cfg/cfg1_out.srec", ".")
shutil.copy("./cfg/cfg1_out.syms", ".")
shutil.copy("./cfg/cfg2_out.tf", ".")

#
# Execute cfg path 3
#
# make command
cfg_command = cfg + " --pass 3 " + "--kernel " + CFG_KERNEL 
cfg_command += " --api-table " + cfg_api_table
cfg_command += " " + cfg_cfg1_def_tables + cfg_includes 
cfg_command += " --rom-image ./DefaultBuild/atk2-sc1.srec --symbol-table ./DefaultBuild/atk2-sc1.syms"
cfg_command += " -T " + cfg_check_tf
if XML_CFG:
	cfg_command += " --ini-file " + cfg_ini_file
cfg_command += " " + proj_rel_dir + cfg_file

print cfg_command

# Execute 
try:
   output = subprocess.check_output(cfg_command, stderr=subprocess.STDOUT,)
except subprocess.CalledProcessError, e:
    print "ERROR!! : ", e.output
    sys.exit()

output.replace('\r','')
print output

#
# dlete pass 1 generated files
#
print "Delete pass 1 generated file"
os.remove("cfg1_out.srec")
os.remove("cfg1_out.syms")
os.remove("cfg2_out.tf")
