#!python
import subprocess
import os
import sys
import re  # for regular expression
import shutil
import os.path

# set relative path from top proj
proj_rel_dir = "../"

# call definition file
common.Source(proj_rel_dir + "def.py")

# path
src_abs_path = os.path.abspath(proj_rel_dir + SRCDIR)

# call common file
common.Source(src_abs_path + "/arch/cx/common.py")

#
# convert map file
#
inputfile = open("./DefaultBuild/cfg.map")
outputfile = open("cfg1_out.syms", 'w')

r = re.compile("^\s+\d+\s+(0x[0-9a-f]+)\s+0x[0-9a-f]+\s+\w+\s+\w+\s+(\w+)")
line = inputfile.readline() 
while line:
    line = line.replace('\r\n','')   #delete newline
    m = r.search(line)
    if m:
        outputfile.write(m.group(1) + " T " + m.group(2) + "\n")
    line = inputfile.readline()

inputfile.close()
outputfile.close()

# remove Os_Lcfg.c
if os.path.isfile('Os_Lcfg.c'):
	os.remove('Os_Lcfg.c')

#
# Execute cfg path 2
#
# make command
cfg_command = cfg + " --pass 2 " + "--kernel " + CFG_KERNEL 
cfg_command += " --api-table " + cfg_api_table
cfg_command += " " + cfg_cfg1_def_tables + cfg_includes 
cfg_command += " -T " + cfg_tf
cfg_command += " " + proj_rel_dir + cfg_file
if XML_CFG:
	cfg_command += " --ini-file " + cfg_ini_file

print cfg_command

# Execute 
try:
   output = subprocess.check_output(cfg_command, stderr=subprocess.STDOUT,)
except subprocess.CalledProcessError, e:
    print "ERROR!! : ", e.output
    sys.exit()

output.replace('\r','')
print output

#
# mov Os_Cfg_tmp.h Os_Cfg.h
#
import filecmp
if not os.path.isfile(r'Os_Cfg.h'):
	print "Rename Os_Cfg_tmp.h to Os_Cfg.h"
	shutil.move("Os_Cfg_tmp.h", "Os_Cfg.h")
else:
	print "compare Os_Cfg_tmp.h and Os_Cfg.h"
	if not filecmp.cmp(r'Os_Cfg_tmp.h', r'Os_Cfg.h'):
		print "Rename Os_Cfg_tmp.h to Os_Cfg.h"
		shutil.move("Os_Cfg_tmp.h", "Os_Cfg.h")
	else:
		print "Delete Os_Cfg_tmp.h"
		os.remove("Os_Cfg_tmp.h")

#
# Execute cfg path 3
#
# make command
cfg_command = cfg + " --pass 3 " + "--kernel " + CFG_KERNEL 
cfg_command += " --api-table " + cfg_api_table
cfg_command += " " + cfg_cfg1_def_tables + cfg_includes 
cfg_command += " --rom-image cfg1_out.srec --symbol-table cfg1_out.syms"
cfg_command += " -T " + cfg_offset_tf
cfg_command += " " + proj_rel_dir + cfg_file
if XML_CFG:
	cfg_command += " --ini-file " + cfg_ini_file

print cfg_command

# Execute 
try:
   output = subprocess.check_output(cfg_command, stderr=subprocess.STDOUT,)
except subprocess.CalledProcessError, e:
    print "ERROR!! : ", e.output
    sys.exit()

output.replace('\r','')
print output