#!python
import subprocess
import os
import sys

# set relative path from top proj
proj_rel_dir = "../"

# call definition file
common.Source(proj_rel_dir + "def.py")

# path
src_abs_path = os.path.abspath(proj_rel_dir + SRCDIR)

# call common file
common.Source(src_abs_path + "/arch/cx/common.py")


#
# tmp arxml file create
#
if XML_CFG:
	base_xml = proj_rel_dir + CFGNAME + '.arxml'
	tmp_xml = proj_rel_dir + cfg_file

	inputstr = ReadFile(base_xml)

	r1 = re.compile("#include.*(\"|<).*?(\"|>)")
	r2 = re.compile("(\"|<).*?(\"|>)")
	
	match = r1.search(inputstr)

	while match:
		inc_str = match.group()

		m = r2.search(inc_str)
		inc_filename = inc_str[m.start()+1 : m.end()-1]

		include_list = [proj_rel_dir + inc_filename]
		for inc_path in INCLUDES:
			include_list = include_list + [src_abs_path + '/' + inc_path  + '/' + inc_filename]

		flg = 0
		for inc_rel_file in include_list:
			if os.path.exists(inc_rel_file):
				sub_str = ReadFile(inc_rel_file)
				inputstr = re.sub(inc_str, sub_str, inputstr)
				flg = 1
				break

		if flg == 0:
			print "ERROR!! : Not Exist %s" % inc_filename
			break

		match = r1.search(inputstr)

	WriteFile_B(tmp_xml, inputstr)

#
# make command
#
cfg_command = cfg + " --pass 1 " + "--kernel " + CFG_KERNEL 
cfg_command += " --api-table " + cfg_api_table
cfg_command += " " + cfg_cfg1_def_tables + cfg_includes 
cfg_command += " " + proj_rel_dir + cfg_file
if XML_CFG:
	cfg_command += " --ini-file " + cfg_ini_file

print cfg_command

#
# Execute cfg path 1
#
try:
   output = subprocess.check_output(cfg_command, stderr=subprocess.STDOUT,)
except subprocess.CalledProcessError, e:
    print "ERROR!! : ", e.output

print output
