/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: prc_config.h 8055 2013-12-17 00:28:18Z fsi-dankei $
 */

/*
 *		ץå¸⥸塼V850ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#include "prc_sil.h"

/*
 *  顼åˡλ
 */
#ifndef CHECK_STKSZ_ALIGN
#define CHECK_STKSZ_ALIGN	4   /* åΥ饤ñ */
#endif /* CHECK_STKSZ_ALIGN */

#ifndef CHECK_FUNC_ALIGN
#define CHECK_FUNC_ALIGN	4   /* ؿΥ饤ñ */
#endif /* CHECK_FUNC_ALIGN */

#define CHECK_FUNC_NONNULL      /* ؿNULLå */

#ifndef CHECK_STACK_ALIGN
#define CHECK_STACK_ALIGN	4   /* åΰΥ饤ñ */
#endif /* CHECK_STACK_ALIGN */

#define CHECK_STACK_NONNULL     /* åΰNULLå */

#define call_errorhook(ercd, svcid)		stack_change_and_call_func_2((void *) &internal_call_errorhook, (ercd), (svcid))
#define call_shutdownhook(ercd)			stack_change_and_call_func_1((void *) &internal_call_shtdwnhk, ((uint32) (ercd)))

/*
 *  ֹϰϤȽ
 */
#if TMIN_INTNO == 0
#define VALID_INTNO(intno)	((intno) <= (InterruptNumberType) (TMAX_INTNO))
#else /* TMIN_INTNO != 0 */
#define VALID_INTNO(intno)	(((InterruptNumberType) (TMIN_INTNO) <= (intno)) && ((intno) <= (InterruptNumberType) (TMAX_INTNO)))
#endif /* TMIN_INTNO == 0 */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  󥿥ƥѤΥåϥɥ쥹ޥ
 */
#define TOPPERS_OSTKPT(stk, stksz)	((StackType *) ((sint8 *) (stk) + (stksz)))

/*
 *  ץåü̿Υ饤ؿ
 */
#include <prc_insn.h>

/*
 *  TOPPERSɸ߽ǥμ¸
 */

/*
 * 㳰ʳ/CPU㳰ˤΥͥȲΥ
 *
 * ƥȻȤΤ˻
 */
extern uint32		except_nest_cnt;

/*
 *  ͥʥƥ2ˤγߤػߤ뤿PMR
 */
extern const uint16	pmr_isr2_mask;

/*
 *  ͥʥƥ1ˤγߤȤʤͥ٤PMRΥӥå
 */
extern const uint16	pmr_isr1_mask;

/*
 *  ߤγͥ٤͡ɽ
 */
extern uint8		current_iintpri;

/*
 * ׵ޥơ֥PMRؤ͡
 */
extern const uint16	pmr_setting_tbl[];

/*
 *  ̵¥롼׽
 */
extern void infinite_loop(void) NoReturn;

/*
 *  ͥ٤ɽȳɽѹ
 */
#ifndef TOPPERS_MACRO_ONLY
#define EXT_IPM(iipm)	((PriorityType) (iipm - (TNUM_INTPRI + 1)))     /* ɽɽ */
#define INT_IPM(ipm)	((uint32) (ipm + (TNUM_INTPRI + 1)))            /* ɽɽ */
#else /* TOPPERS_MACRO_ONLY */
#define EXT_IPM(iipm)	(iipm - (TNUM_INTPRI + 1))              /* ɽɽ */
#define INT_IPM(ipm)	(ipm + (TNUM_INTPRI + 1))               /* ɽɽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ߶ػ߾֤ؤΰܹ
 */
LOCAL_INLINE void
x_lock_all_int(void)
{
	disable_int();
}

/*
 *  ߶ػ߾֤β
 */
LOCAL_INLINE void
x_unlock_all_int(void)
{
	enable_int();
}

/*
 *  x_nested_lock_os_int()ΥͥȲ
 *  νѲʤ褦volatile 
 */
extern volatile uint8 nested_lock_os_int_cnt;

/*
 *  OS߶ػ
 *  API¹Ի˸ƤӽФ
 *  ͥ٥ޥISR2ͥ٥ޥϰϤ⤤֤ǸƤӽФ
 *  ȤϤʤ(ISR1ƤӽФ뤳ȤϤʤ)
 */
LOCAL_INLINE void
x_nested_lock_os_int(void)
{
	/*
	 *  ܤʤߤζػߥ٥ͥ٥ޥͤ¸
	 */
	if (nested_lock_os_int_cnt == 0U) {
		sil_wrh_mem((void *) PMR, pmr_isr2_mask);   /* OS߶ػߤ */
	}
	nested_lock_os_int_cnt++;

	V850_MEMORY_CHANGED
}

/*
 *  OS߲
 *  API¹Ի˸ƤӽФ
 *  ͥ٥ޥISR2ͥ٥ޥϰϤ⤤֤ǸƤӽФ
 *  ȤϤʤ(ISR1ƤӽФ뤳ȤϤʤ)
 */
LOCAL_INLINE void
x_nested_unlock_os_int(void)
{
	V850_MEMORY_CHANGED
	ASSERT(nested_lock_os_int_cnt > 0U);
	nested_lock_os_int_cnt--;

	/*
	 *  ֳ¦ʤͥ٥ޥ򹹿
	 */
	if (nested_lock_os_int_cnt == 0U) {
		sil_wrh_mem((void *) PMR, pmr_setting_tbl[current_iintpri]);
	}
}

/*
 *  SuspendOSInterrupts()ƤӽФOS߶ػ߾֤ؤΰܹ
 *  x_nested_lock_os_int()Ȥΰ㤤ϡISR1ƤӽФǽ뤿ᡤ
 *  ߤISPROS߶ػ߻ͤ꾮ISR1ƤӽФ줿Ȥơ
 *  ⤻꥿󤹤
 */
LOCAL_INLINE void
x_suspend_lock_os_int(void)
{
	uint16 ispr;

	ispr = sil_reh_mem((void *) ISPR_H);

	if ((ispr & pmr_isr1_mask) == 0U) {
		/*
		 *  ƥ1 ISRƤФ줿ϲ⤷ʤ
		 */
		if (nested_lock_os_int_cnt == 0U) {
			sil_wrh_mem((void *) PMR, pmr_isr2_mask);   /* OS߶ػߤ */
		}
		nested_lock_os_int_cnt++;
		V850_MEMORY_CHANGED
	}
}

/*
 *  ResumeOSInterrupts()ƤӽФOS߶ػ߾֤β
 *  x_nested_lock_os_int()Ȥΰ㤤ϡISR1ƤӽФǽ뤿ᡤ
 *  ߤISPROS߶ػ߻ͤ꾮ISR1ƤӽФ줿Ȥơ
 *  ⤻꥿󤹤
 */
LOCAL_INLINE void
x_resume_unlock_os_int(void)
{
	uint16	ispr;

	V850_MEMORY_CHANGED
			ispr = sil_reh_mem((void *) ISPR_H);

	if ((ispr & pmr_isr1_mask) == 0U) {
		/*
		 *  ƥ1 ISRƤФ줿ϲ⤷ʤ
		 */
		ASSERT(nested_lock_os_int_cnt > 0U);
		nested_lock_os_int_cnt--;

		/*
		 *  ֳ¦ʤͥ٥ޥ򹹿
		 */
		if (nested_lock_os_int_cnt == 0U) {
			sil_wrh_mem((void *) PMR, pmr_setting_tbl[current_iintpri]);
		}
	}
}


/*
 *  (ǥ)ͥ٥ޥ
 *
 *  OSǤϼΩ
 *    * OS߶ػ߾֤ǸƤӽФ
 *    * OS߶ػ߻ͥ٤⤤ͤϻꤵʤ
 */
LOCAL_INLINE void
x_set_ipm(PriorityType intpri)
{
	ASSERT(nested_lock_os_int_cnt > 0U);

	current_iintpri = INT_IPM(intpri);
	sil_wrh_mem((void *) PMR, pmr_setting_tbl[current_iintpri]);
}

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  OSǤϼΩ
 *    * OS߶ػ߾֤ǸƤӽФ
 */
LOCAL_INLINE PriorityType
x_get_ipm(void)
{
	ASSERT(nested_lock_os_int_cnt > 0U);
	return(EXT_IPM(current_iintpri));
}

/*
 *  ׵ػߥե饰Υå
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
LOCAL_INLINE boolean
x_disable_int(InterruptNumberType intno)
{
	uint32 eic_address = EIC_ADDRESS(intno);

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	/* ߤζػ(7bitܤ򥻥å) */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) | (0x01U << 7));

	return(TRUE);
}
/*
 *  ׵ػߥե饰β
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */

LOCAL_INLINE boolean
x_enable_int(InterruptNumberType intno)
{
	uint32 eic_address = EIC_ADDRESS(intno);

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	/* 7bitܤ򥯥ꥢ */
	sil_wrb_mem((void *) eic_address,
				sil_reb_mem((void *) eic_address) & ~(0x01U << 7));

	return(TRUE);
}

/*
 *  ׵Υꥢ
 */
LOCAL_INLINE boolean
x_clear_int(InterruptNumberType intno)
{
	uint32 eic_address = EIC_ADDRESS(intno);

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	/* ߤΥꥢ(12bitܤ򥯥ꥢ) */
	sil_wrh_mem((void *) eic_address,
				sil_reh_mem((void *) eic_address) & ~(0x01U << 12));

	return(TRUE);
}

/*
 *  ׵Υå
 */
LOCAL_INLINE boolean
x_probe_int(InterruptNumberType intno)
{
	uint32	eic_address = EIC_ADDRESS(intno);
	uint16	tmp;

	if (!VALID_INTNO(intno)) {
		return(FALSE);
	}

	tmp = sil_reh_mem((void *) (eic_address));
	return((tmp & 0x1000) != 0);
}

/*
 *  ׵饤°
 */
extern void x_config_int(InterruptNumberType intno, AttributeType intatr, PriorityType intpri);

/*
 *  ߥϥɥɬפIRC
 */
LOCAL_INLINE void
i_begin_int(InterruptNumberType intno)
{

}

/*
 *  ߥϥɥνиɬפIRC
 */
LOCAL_INLINE void
i_end_int(InterruptNumberType intno)
{

}

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);
extern void start(void);
extern void prc_hardware_initialize(void);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatch ϡƥȤƤӽФ줿ӥ
 *  ǡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡߶ػ߾֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatch ϡOS߶ػ߾֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void			*sp;        /* åݥ */
	FunctionRefType	pc;         /* ץ५ */
} TSKCTXB;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ
 */
extern void start_r(void);

#define activate_context(p_tcb) do {									  \
		(p_tcb)->tskctxb.sp = (void *) ((char8 *) ((p_tcb)->p_tinib->stk) \
										+ (p_tcb)->p_tinib->stksz);		  \
		(p_tcb)->tskctxb.pc = (FunctionRefType) start_r;				  \
} while (0)

/* ηϥϡɥ륵uint32ˤƱ */
extern void stack_change_and_call_func_1(void *func, uint32 arg1);
extern void stack_change_and_call_func_2(void *func, uint8 arg1, uint8 arg2);

#ifdef ENABLE_RETURN_MAIN
/*
 *  AKTSPѤmain()ؤΥ꥿󥳡ɡprc_support.S
 */
extern void return_main(void);
#endif /* ENABLE_RETURN_MAIN */

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_PRC_CONFIG_H */
