/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: taua_timer.c 8024 2013-11-29 07:51:49Z shigihara $
 */

/*
 *		ޥɥ饤СTAUA0 Timer
 */

#include "kernel_impl.h"
#include "target_timer.h"
#include "taua_timer.h"
#include "Os_Lcfg.h"

/*
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
SystemTimeMsType current_time;

/*
 *	ؿץȥ
 */
ISR(target_timer_hdr);

/*
 *  ޥñ̤Ǥλ
 */
SystemTimeUsType
get_tim_utime(void)
{
	SystemTimeUsType	utime;
	SystemTimeMsType	mtime;
	TickType			clock1, clock2;
	boolean				ireq;
	SIL_PRE_LOC;

	SIL_LOC_INT();
	mtime = current_time;
	clock1 = target_timer_get_current();
	ireq = target_timer_probe_int();
	clock2 = target_timer_get_current();
	SIL_UNL_INT();
	utime = ((SystemTimeUsType) mtime) * 1000U;

	if ((ireq != FALSE) && (clock2 >= clock1)) {
		/*
		 *  ߤäƤꡤclock2clock1礭ޤϡ
		 *  current_time ߤˤ깹Ƥʤġclock1ϥХե
		 *  ͤǤ뤿ᡤutime1mɲä롥clock1ɤ߹ߡߤΥå
		 *  clock2ɤ߹ߤ1sʲǼ¹Բǽʥץå¸ߤ뤿ᡤդ
		 *  ӤƤ롥
		 */
		utime += 1000U;
	}
	utime += TO_USEC(clock1);

	return(utime);
}

SystemTimeUsType
get_tim_100ntime(void)
{
	SystemTimeUsType	utime;
	SystemTimeMsType	mtime;
	TickType			clock1, clock2;
	boolean				ireq;
	SIL_PRE_LOC;

	SIL_LOC_INT();
	mtime = current_time;
	clock1 = target_timer_get_current();
	ireq = target_timer_probe_int();
	clock2 = target_timer_get_current();
	SIL_UNL_INT();
	utime = ((SystemTimeUsType) mtime) * 10000U;

	if ((ireq != FALSE) && (clock2 >= clock1)) {
		/*
		 *  ߤäƤꡤclock2clock1礭ޤϡ
		 *  current_time ߤˤ깹Ƥʤġclock1ϥХե
		 *  ͤǤ뤿ᡤutime1mɲä롥clock1ɤ߹ߡߤΥå
		 *  clock2ɤ߹ߤ1sʲǼ¹Բǽʥץå¸ߤ뤿ᡤդ
		 *  ӤƤ롥
		 */
		utime += 10000U;
	}
	utime += TO_100NSEC(clock1);

	return(utime);
}

/*
 *  ޤεư
 *
 *  ޤϥ0
 */
void
target_timer_initialize(void)
{
	uint16 wk;
	current_time = 0U;

	wk = sil_reh_mem((void *) TAUA0TPS);
	wk &= ~MCU_TAUA0_MASK_CK0;
	wk |= MCU_TAUA0_CK0;
	sil_wrh_mem((void *) TAUA0TPS, wk);                         /* Set prescaler value for CK0  */

	sil_wrh_mem((void *) TAUA0CMOR(0), MCU_TAUA00_CMOR);        /* 󥿡Х륿ޤȤƻ */
	sil_wrb_mem((void *) TAUA0CMUR(0), MCU_TAUA00_CMUR);

	sil_wrh_mem((void *) TAUA0CDR(0), TIMER_CLOCK);             /* 1ms */

	wk = sil_reh_mem((void *) TAUA0TE);
	wk |= 0x0001;                                                   /* TAUT0ͥ룰 */
	sil_wrh_mem((void *) TAUA0TS, wk);                              /* ư */
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(void)
{
	uint16 wk;

	/*  */
	wk = sil_reh_mem((void *) TAUA0TE);
	wk &= ~0x0001;                                          /* ͥ0 */
	sil_wrh_mem((void *) TAUA0TT, wk);                      /* ư */

	/* ߤζػߤȥꥢ */
	x_disable_int(TAUA0_IRQ);
	x_clear_int(TAUA0_IRQ);
}

/*
 *  target_timer.cfgINCLUDEʤн
 */
#ifndef SysTimerCnt
#define SysTimerCnt		UINT_C(0)
#endif /* SysTimerCnt */

/*
 *  ޳ߥϥɥ
 */
ISR(target_timer_hdr)
{
	StatusType ercd;

	/* current_time򹹿 */
	current_time++;

	/*
	 *  󥿲ûν¹
	 */
	ercd = IncrementCounter(SysTimerCnt);
	/* 顼꥿ξϥåȥ */
	if (ercd != E_OK) {
		ShutdownOS(ercd);
	}
}
