/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2011-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: allfunc.h 8032 2013-12-09 04:38:30Z fsi-dankei $
 */

/*
 *		٤Ƥδؿ򥳥ѥ뤹뤿
 */

#ifndef TOPPERS_ALLFUNC_H
#define TOPPERS_ALLFUNC_H

/* alarm.c */
#define TOPPERS_alarm_initialize
#define TOPPERS_GetAlarmBase
#define TOPPERS_GetAlarm
#define TOPPERS_SetRelAlarm
#define TOPPERS_SetAbsAlarm
#define TOPPERS_CancelAlarm
#define TOPPERS_alarm_expire

/* counter_manage.c */
#define TOPPERS_IncrementCounter
#define TOPPERS_GetCounterValue
#define TOPPERS_GetElapsedValue
#define TOPPERS_notify_hardware_counter
#define TOPPERS_incr_counter_action

/* counter.c */
#define TOPPERS_insert_cnt_expr_que
#define TOPPERS_delete_cnt_expr_que
#define TOPPERS_counter_initialize
#define TOPPERS_counter_terminate
#define TOPPERS_get_reltick
#define TOPPERS_get_abstick
#define TOPPERS_expire_process

/* event.c */
#define TOPPERS_SetEvent
#define TOPPERS_ClearEvent
#define TOPPERS_GetEvent
#define TOPPERS_WaitEvent
#define TOPPERS_set_event_action

/* interrupt.c */
#define TOPPERS_interrupt_initialize
#define TOPPERS_release_interrupts
#define TOPPERS_exit_isr2
#define TOPPERS_release_isrresources

/* interrupt_manage.c */
#define TOPPERS_DisableAllInterrupts
#define TOPPERS_EnableAllInterrupts
#define TOPPERS_SuspendAllInterrupts
#define TOPPERS_ResumeAllInterrupts
#define TOPPERS_SuspendOSInterrupts
#define TOPPERS_ResumeOSInterrupts
#define TOPPERS_GetISRID

/* osctl.c */
#define TOPPERS_internal_call_errorhook
#define TOPPERS_call_posttaskhook
#define TOPPERS_call_pretaskhook
#define TOPPERS_call_protectionhk_main
#define TOPPERS_init_stack_magic_region
#define TOPPERS_internal_shutdownos
#define TOPPERS_internal_call_shtdwnhk

/* osctl_manage.c */
#define TOPPERS_StartOS
#define TOPPERS_GetActiveApplicationMode
#define TOPPERS_ShutdownOS
#define TOPPERS_GetFaultyContext

/* resource.c */
#define TOPPERS_resource_initialize
#define TOPPERS_GetResource
#define TOPPERS_ReleaseResource

/* scheduletable.c */
#define TOPPERS_schtbl_initialize
#define TOPPERS_StartScheduleTableRel
#define TOPPERS_StartScheduleTableAbs
#define TOPPERS_StopScheduleTable
#define TOPPERS_NextScheduleTable
#define TOPPERS_GetScheduleTableStatus
#define TOPPERS_schtbl_expire
#define TOPPERS_schtbl_expiry_process
#define TOPPERS_schtbl_head
#define TOPPERS_schtbl_exppoint_process
#define TOPPERS_schtbl_tail

/* task.c */
#define TOPPERS_task_initialize
#define TOPPERS_search_schedtsk
#define TOPPERS_make_runnable
#define TOPPERS_make_non_runnable
#define TOPPERS_make_active
#define TOPPERS_preempt
#define TOPPERS_suspend
#define TOPPERS_release_taskresources
#define TOPPERS_exit_task

/* task_manage.c */
#define TOPPERS_ActivateTask
#define TOPPERS_TerminateTask
#define TOPPERS_ChainTask
#define TOPPERS_Schedule
#define TOPPERS_GetTaskID
#define TOPPERS_GetTaskState
#define TOPPERS_activate_task_action

#endif /* TOPPERS_ALLFUNC_H */
