/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: osctl_manage.c 7905 2013-09-25 08:20:15Z whirahashi $
 */

/*
 *		OS⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "interrupt.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_GETAAM_ENTER
#define LOG_GETAAM_ENTER()
#endif /* LOG_GETAAM_ENTER */

#ifndef LOG_GETAAM_LEAVE
#define LOG_GETAAM_LEAVE(mode)
#endif /* LOG_GETAAM_LEAVE */

#ifndef LOG_STAOS_ENTER
#define LOG_STAOS_ENTER(mode)
#endif /* LOG_STAOS_ENTER */

#ifndef LOG_STAOS_LEAVE
#define LOG_STAOS_LEAVE()
#endif /* LOG_STAOS_LEAVE */

#ifndef LOG_STAHOOK_ENTER
#define LOG_STAHOOK_ENTER()
#endif /* LOG_STAHOOK_ENTER */

#ifndef LOG_STAHOOK_LEAVE
#define LOG_STAHOOK_LEAVE()
#endif /* LOG_STAHOOK_LEAVE */


#ifdef TOPPERS_StartOS

/*
 *  OS¹Τѿ
 */
uint16		callevel_stat = 0U;             /* ¹Υƥ */
AppModeType	appmodeid;                      /* ץꥱ⡼ID */

/*
 *  ͥư֥ե饰
 */
boolean		kerflg = FALSE;

/*
 *  եֹ̾λѤѿ
 */
const char8	*fatal_file_name = NULL;                    /* ե̾ */
sint32		fatal_line_num = 0;                         /* ֹ */

/*
 *  OSεư
 */

void
StartOS(AppModeType Mode)
{
#ifdef CFG_USE_STARTUPHOOK
	void (*volatile startuphook_adr) (void);
#endif /* CFG_USE_STARTUPHOOK */

	LOG_STAOS_ENTER(Mode);
#ifdef CFG_USE_EXTENDEDSTATUS
	if (kerflg != FALSE) {
		/* OSưϥ顼եåƤ */
#ifdef CFG_USE_ERRORHOOK
		x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
		_errorhook_par1.mode = Mode;
#endif /* CFG_USE_PARAMETERACCESS */
		call_errorhook(E_OS_ACCESS, OSServiceId_StartOS);
		x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */
	}
	else {
#endif /* CFG_USE_EXTENDEDSTATUS */

		/* ߶ػ߾֤˰ܹ */
		x_lock_all_int();

#ifdef CFG_USE_STACKMONITORING
		/*
		 *  å˥󥰵ǽν
		 *  å˥󥰵ǽΤΥޥåʥСΰν
		 */
		init_stack_magic_region();
#endif /* CFG_USE_STACKMONITORING */

		/* ץꥱ⡼ɤ */
		appmodeid = Mode;

		/* åȰ¸ν */
		target_initialize();

		/* ƥ⥸塼ν */
		object_initialize();

		callevel_stat = TCL_NULL;

		/* ͥư */
		kerflg = TRUE;

		/*
		 *  ModeǤä硤OSåȥԤ
		 *  λȥåץեåϸƤӽФʤ
		 */
		if (Mode >= tnum_appmode) {
			/*
			 *  internal_shutdownosƤOS߶ػ߾֤
			 *  ߶ػ߾ֲ
			 */
			x_nested_lock_os_int();
			x_unlock_all_int();
			internal_shutdownos(E_OS_MODE);
		}

#ifdef CFG_USE_STARTUPHOOK
		/* OS߶ػ߾֤ˤ߶ػ߾ֲ */
		x_nested_lock_os_int();
		x_unlock_all_int();

		/*
		 *  StartupHook θƤӽФ
		 *
		 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
		 *  ѥκŬˤStartupHookΥɥ쥹Ƚʬ
		 *  Ƥޤ礬뤿, volatileꤷѿ
		 *  ɥ쥹ƤȽꤷƤ
		 */
		startuphook_adr = &StartupHook;

		if (startuphook_adr != NULL) {
			ENTER_CALLEVEL(TCL_STARTUP);
			LOG_STAHOOK_ENTER();
			StartupHook();
			LOG_STAHOOK_LEAVE();
			LEAVE_CALLEVEL(TCL_STARTUP);

			release_interrupts(OSServiceId_HookMissingEnd);
		}

		/* γߥޥͥ٤߶ػ߾֤ */
		x_lock_all_int();
		x_nested_unlock_os_int();
#endif /* CFG_USE_STARTUPHOOK */

		ENTER_CALLEVEL(TCL_TASK);
		LOG_STAOS_LEAVE();
		start_dispatch();
		ASSERT(0);
#ifdef CFG_USE_EXTENDEDSTATUS
	}
#endif /* CFG_USE_EXTENDEDSTATUS */
}

#endif /* TOPPERS_StartOS */

/*
 *  ߤΥץꥱ⡼ɤμ
 */
#ifdef TOPPERS_GetActiveApplicationMode

AppModeType
GetActiveApplicationMode(void)
{
	AppModeType	appmode;
#if defined(CFG_USE_EXTENDEDSTATUS) || defined(CFG_USE_ERRORHOOK)
	StatusType	ercd;
#endif /* CFG_USE_EXTENDEDSTATUS || CFG_USE_ERRORHOOK */

	LOG_GETAAM_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_GETACTIVEAPPMODE);

	appmode = appmodeid;

  exit_finish:
	LOG_GETAAM_LEAVE(appmode);
	return(appmode);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	/*
	 *  顼ȯINVALID_APPMODETYPE֤뤬顼ȯΤ¹
	 *  C2ISR¸ߤʤΤ̤뤿ᡤ顼եåƤ
	 */
	call_errorhook(ercd, OSServiceId_GetActiveApplicationMode);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	appmode = INVALID_APPMODETYPE;
	goto exit_finish;
}

#endif /* TOPPERS_GetActiveApplicationMode */

/*
 *  OSνλ
 */
#ifdef TOPPERS_ShutdownOS

void
ShutdownOS(StatusType Error)
{
	StatusType ercd = Error;

	/*
	 *  ʽñ̤ƤӽФ⡤ErrorE_OS_SHUTDOWN_FATALȤ
	 *  ShutdownOSƤӽФΤȤơåȥԤ
	 */
	if (((callevel_stat & TCLMASK) | (CALLEVEL_SHUTDOWNOS)) != (CALLEVEL_SHUTDOWNOS)) {
		ercd = E_OS_SHUTDOWN_FATAL;
	}

	/*
	 *  OSƤʤ顼ɤꤵ줿硤ErrorE_OS_SHUTDOWN_FATALȤ
	 *  ShutdownOSƤӽФΤȤơåȥԤ
	 */
	if (ercd > ERRCODE_NUM) {
		ercd = E_OS_SHUTDOWN_FATAL;
	}

	internal_shutdownos(ercd);
}
#endif /* TOPPERS_ShutdownOS */

/*
 *  ݸȿ򵯤ñ̤μ
 */
#ifdef TOPPERS_GetFaultyContext

FaultyContextType
GetFaultyContext(void)
{
	FaultyContextType faultycontext = FC_INVALID;

#ifdef CFG_USE_PROTECTIONHOOK
	if ((callevel_stat & CALLEVEL_GETFAULTYCONTEXT) != 0U) {

		/* C1ISRʳȯ */
		if ((callevel_stat & TSYS_ISR1) == 0U) {
			/* եåȯ */
			if ((callevel_stat & (TCL_ERROR | TCL_PREPOST | TCL_STARTUP | TCL_SHUTDOWN)) != 0U) {
				/* ƥեåȯ */
				faultycontext = FC_SYSTEM_HOOK;
			}
			else if ((callevel_stat & TCL_ISR2) != 0U) {
				if ((callevel_stat & TCL_ALRMCBAK) == 0U) {
					faultycontext = FC_C2ISR;
				}
			}
			else if ((callevel_stat & TCL_TASK) != 0U) {
				if ((callevel_stat & TCL_ALRMCBAK) == 0U) {
					faultycontext = FC_TASK;
				}
			}
			else {
				/* 嵭ʳξ硤ϹԤʤ(͡FC_INVALID) */
			}
		}
	}
#endif /* CFG_USE_PROTECTIONHOOK */

	return(faultycontext);
}
#endif /* TOPPERS_GetFaultyContext */
