/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2011-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: task_manage.c 7993 2013-10-23 08:19:53Z fsi-dankei $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_TSKSTAT
#define LOG_TSKSTAT(p_tcb)
#endif /* LOG_TSKSTAT */

#ifndef LOG_ACTTSK_ENTER
#define LOG_ACTTSK_ENTER(tskid)
#endif /* LOG_ACTTSK_ENTER */

#ifndef LOG_ACTTSK_LEAVE
#define LOG_ACTTSK_LEAVE(ercd)
#endif /* LOG_ACTTSK_LEAVE */

#ifndef LOG_TERTSK_ENTER
#define LOG_TERTSK_ENTER()
#endif /* LOG_TERTSK_ENTER */

#ifndef LOG_TERTSK_LEAVE
#define LOG_TERTSK_LEAVE(ercd)
#endif /* LOG_TERTSK_LEAVE */

#ifndef LOG_CHNTSK_ENTER
#define LOG_CHNTSK_ENTER(tskid)
#endif /* LOG_CHNTSK_ENTER */

#ifndef LOG_CHNTSK_LEAVE
#define LOG_CHNTSK_LEAVE(ercd)
#endif /* LOG_CHNTSK_LEAVE */

#ifndef LOG_SCHED_LEAVE
#define LOG_SCHED_ENTER()
#endif /* LOG_SCHED_LEAVE */

#ifndef LOG_SCHED_LEAVE
#define LOG_SCHED_LEAVE(ercd)
#endif /* LOG_SCHED_LEAVE */

#ifndef LOG_GETTID_ENTER
#define LOG_GETTID_ENTER()
#endif /* LOG_GETTID_ENTER */

#ifndef LOG_GETTID_LEAVE
#define LOG_GETTID_LEAVE(ercd, p_tskid)
#endif /* LOG_GETTID_LEAVE */

#ifndef LOG_GETTST_ENTER
#define LOG_GETTST_ENTER(tskid)
#endif /* LOG_GETTST_ENTER */

#ifndef LOG_GETTST_LEAVE
#define LOG_GETTST_LEAVE(ercd, p_state)
#endif /* LOG_GETTST_LEAVE */


/*
 *  εư
 */
#ifdef TOPPERS_ActivateTask

StatusType
ActivateTask(TaskType TaskID)
{
	StatusType	ercd = E_OK;
	TCB			*p_tcb;

	LOG_ACTTSK_ENTER(TaskID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_ACTIVATETASK);
	CHECK_ID(TaskID < tnum_task);
	p_tcb = get_tcb(TaskID);

	x_nested_lock_os_int();
	if (p_tcb->tstat == SUSPENDED) {
		if ((make_active(p_tcb) != FALSE) && (callevel_stat == TCL_TASK)) {
			dispatch();
		}
	}
	else {
		S_D_CHECK_LIMIT(p_tcb->actcnt < p_tcb->p_tinib->maxact);

		p_tcb->actcnt += 1U;
	}

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_ACTTSK_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
  d_exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	_errorhook_par1.tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_ActivateTask);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_ActivateTask */

/*
 *  νλ
 */
#ifdef TOPPERS_TerminateTask

StatusType
TerminateTask(void)
{
	StatusType ercd = E_OK;

	LOG_TERTSK_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_TERMINATETASK);
	CHECK_RESOURCE(p_runtsk->p_lastrescb == NULL);

	x_nested_lock_os_int();
	/*
	 *  ꥽βͥ٤򲼤ʤΤǡǤ
	 *  ⤷ʤƤ褤
	 */

	suspend();

	LOG_TERTSK_LEAVE(E_OK);
	exit_and_dispatch();
	/* ˤäƤʤ */

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_TerminateTask);
	x_nested_unlock_os_int();
#endif /* CFG_USE_ERRORHOOK */

  exit_no_errorhook:
	LOG_TERTSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_TerminateTask */

/*
 *  νλȥεư
 */
#ifdef TOPPERS_ChainTask

StatusType
ChainTask(TaskType TaskID)
{
	/*
	 *  Ǥ ercd νפǤ뤬ѥη
	 *  å򤱤뤿˽Ƥ
	 */
	StatusType	ercd = E_OK;
	TCB			*p_tcb;

	LOG_CHNTSK_ENTER(TaskID);
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_CHAINTASK);
	CHECK_RESOURCE(p_runtsk->p_lastrescb == NULL);
	CHECK_ID(TaskID < tnum_task);
	p_tcb = get_tcb(TaskID);

	x_nested_lock_os_int();
	if (p_tcb == p_runtsk) {
		make_non_runnable();
		(void) make_active(p_runtsk);
	}
	else {
		/*
		 *  顼ѤĤʤ褦ˡ顼å
		 *  λ˹Ԥɬפ
		 */
		S_D_CHECK_LIMIT((p_tcb->tstat == SUSPENDED)
						|| (p_tcb->actcnt < p_tcb->p_tinib->maxact));

		suspend();

		if (p_tcb->tstat == SUSPENDED) {
			(void) make_active(p_tcb);
		}
		else {
			p_tcb->actcnt += 1U;
		}
	}

	LOG_CHNTSK_LEAVE(E_OK);
	exit_and_dispatch();
	/* ˤäƤʤ */

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
  d_exit_errorhook:
#ifdef CFG_USE_PARAMETERACCESS
	_errorhook_par1.tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_ChainTask);
#endif /* CFG_USE_ERRORHOOK */

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_CHNTSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_ChainTask */

/*
 *  塼θƤӽФ
 */
#ifdef TOPPERS_Schedule

StatusType
Schedule(void)
{
	/*
	 *  Ǥ ercd νפǤ뤬ѥη
	 *  å򤱤뤿˽Ƥ
	 */
	StatusType ercd = E_OK;

	LOG_SCHED_ENTER();
	CHECK_DISABLEDINT();
	CHECK_CALLEVEL(CALLEVEL_SCHEDULE);
	CHECK_RESOURCE(p_runtsk->p_lastrescb == NULL);

	x_nested_lock_os_int();
	if (p_runtsk->p_tinib->inipri > nextpri) {
		p_runtsk->curpri = p_runtsk->p_tinib->inipri;
		preempt();
		dispatch();
		p_runtsk->curpri = p_runtsk->p_tinib->exepri;
	}

  d_exit_no_errorhook:
	x_nested_unlock_os_int();
  exit_no_errorhook:
	LOG_SCHED_LEAVE(ercd);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
	call_errorhook(ercd, OSServiceId_Schedule);
	goto d_exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_Schedule */

/*
 *  ¹Ծ֤ΥIDλ
 */
#ifdef TOPPERS_GetTaskID

StatusType
GetTaskID(TaskRefType TaskID)
{
	StatusType ercd = E_OK;

	LOG_GETTID_ENTER();
	CHECK_CALLEVEL(CALLEVEL_GETTASKID);
	CHECK_PARAM_POINTER(TaskID);
	*TaskID = (p_runtsk == NULL) ? INVALID_TASK : TSKID(p_runtsk);

  exit_no_errorhook:
	LOG_GETTID_LEAVE(ercd, TaskID);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	_errorhook_par1.p_tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetTaskID);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_GetTaskID */

/*
 *  ֤λ
 */
#ifdef TOPPERS_GetTaskState

StatusType
GetTaskState(TaskType TaskID, TaskStateRefType State)
{
	StatusType	ercd = E_OK;
	TCB			*p_tcb;

	LOG_GETTST_ENTER(TaskID);
	CHECK_CALLEVEL(CALLEVEL_GETTASKSTATE);
	CHECK_ID(TaskID < tnum_task);
	CHECK_PARAM_POINTER(State);
	p_tcb = get_tcb(TaskID);

	*State = (p_tcb == p_runtsk) ? RUNNING : p_tcb->tstat;

  exit_no_errorhook:
	LOG_GETTST_LEAVE(ercd, State);
	return(ercd);

#ifdef CFG_USE_ERRORHOOK
  exit_errorhook:
	x_nested_lock_os_int();
#ifdef CFG_USE_PARAMETERACCESS
	_errorhook_par1.tskid = TaskID;
	_errorhook_par2.p_stat = State;
#endif /* CFG_USE_PARAMETERACCESS */
	call_errorhook(ercd, OSServiceId_GetTaskState);
	x_nested_unlock_os_int();
	goto exit_no_errorhook;
#endif /* CFG_USE_ERRORHOOK */
}

#endif /* TOPPERS_GetTaskState */

/*
 *  λѥεư
 *
 *  OS߶ػ߾֤ǸƤФ
 */
#ifdef TOPPERS_activate_task_action

void
activate_task_action(TaskType TaskID)
{
	StatusType	ercd = E_OK;
	TCB			*p_tcb;

	LOG_ACTTSK_ENTER(TaskID);
	p_tcb = get_tcb(TaskID);

	if (p_tcb->tstat == SUSPENDED) {
		(void) make_active(p_tcb);
	}
	else if (p_tcb->actcnt < p_tcb->p_tinib->maxact) {
		p_tcb->actcnt += 1U;
	}
	else {
		ercd = E_OS_LIMIT;
#ifdef CFG_USE_ERRORHOOK
#ifdef CFG_USE_PARAMETERACCESS
		_errorhook_par1.tskid = TaskID;
#endif /* CFG_USE_PARAMETERACCESS */
		call_errorhook(ercd, OSServiceId_ActivateTask);
#endif /* CFG_USE_ERRORHOOK */
	}

	LOG_ACTTSK_LEAVE(ercd);
}

#endif /* TOPPERS_activate_task_action */
