/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 8024 2013-11-29 07:51:49Z shigihara $
 */

/*
 *		åȰ¸⥸塼FL-V850E2/FL4ѡ
 */

#include "kernel_impl.h"
#include "v850e2_gcc/uart.h"
#include "v850e2_gcc/prc_sil.h"
#include "target_sysmod.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ʸν
 */
void
target_fput_str(const char8 *c)
{
	while (*c != '\0') {
		uart_putc(*c);
		c++;
	}
	uart_putc('\n');
}

/********************************************************************************************/
/*  Function Name : V850Drv_led_output                                                      */
/*  Input         : set LED information, LED ON/OFF information                             */
/*  Output        : none                                                                    */
/*  Description   : Switch ON/OFF LED1-4                                                    */
/********************************************************************************************/
void
V850Drv_led_output(uint16 Data_u16, uint8 LedOnOff_u08) /* FIXME */
{
	uint16	P24_MaskValue_u16;
	uint16	P24_SetValue_u16;

	P24_MaskValue_u16 = Data_u16;
	P24_MaskValue_u16 &= MASK_LED1TO4;
	P24_MaskValue_u16 <<= P24_LED_GAP;

	/* LED ON/OFF check */
	if (LedOnOff_u08 == 1) {
		P24_SetValue_u16 = sil_reh_mem((void *) P(24));
		P24_SetValue_u16 &= ~P24_MaskValue_u16;
		sil_wrh_mem((void *) P(24), P24_SetValue_u16);
		/*    P24 &= ~P24_MaskValue; */
	}
	else if (LedOnOff_u08 == 0) {
		P24_SetValue_u16 = sil_reh_mem((void *) P(24));
		P24_SetValue_u16 |= P24_MaskValue_u16;
		sil_wrh_mem((void *) P(24), P24_SetValue_u16);
		/*    P24 |= P4_MaskValue; */
	}
	else {
		/* Insert error code */
	}
} /* V850Drv_led_output */

/*
 *  ݡȤν
 */
void
target_port_initialize(void)
{
	uint16 wk;

	/* PORT24(LED) */
	/* PMC24  */
	wk = sil_reh_mem((void *) PMC(24));
	wk &= ~P24_MASK;
	wk |= (PMC24_INIT & P24_MASK);
	sil_wrh_mem((void *) PMC(24), wk);

	/* PFCE24  */
	wk = sil_reh_mem((void *) PFCE(24));
	wk &= ~P24_MASK;
	wk |= (PFCE24_INIT & P24_MASK);
	sil_wrh_mem((void *) PFCE(24), wk);

	/* PFC24  */
	wk = sil_reh_mem((void *) PFC(24));
	wk &= ~P24_MASK;
	wk |= (PFC24_INIT & P24_MASK);
	sil_wrh_mem((void *) PFC(24), wk);

	/* PM24  */
	wk = sil_reh_mem((void *) PM(24));
	wk &= ~P24_MASK;
	wk |= (PM24_INIT & P24_MASK);
	sil_wrh_mem((void *) PM(24), wk);

	/* P24  */
	wk = sil_reh_mem((void *) P(24));
	wk &= ~P24_MASK;
	wk |= (P24_INIT & P24_MASK);
	sil_wrh_mem((void *) P(24), wk);

#if TARGET_UARTE_PORT == 3
	/* PORT3(UARTE3) */
	/* PMC3  */
	wk = sil_reh_mem((void *) PMC(3));
	wk &= ~UARTE3_P3_MASK;
	wk |= (UARTE3_PMC3_INIT & UARTE3_P3_MASK);
	sil_wrh_mem((void *) PMC(3), wk);

	/* PFC3  */
	wk = sil_reh_mem((void *) PFC(3));
	wk &= ~UARTE3_P3_MASK;
	wk |= (UARTE3_PFC3_INIT & UARTE3_P3_MASK);
	sil_wrh_mem((void *) PFC(3), wk);

	/* PFCE3  */
	wk = sil_reh_mem((void *) PFCE(3));
	wk &= ~UARTE3_P3_MASK;
	wk |= (UARTE3_PFCE3_INIT & UARTE3_P3_MASK);
	sil_wrh_mem((void *) PFCE(3), wk);

	/* PM3  */
	wk = sil_reh_mem((void *) PM(3));
	wk &= ~UARTE3_P3_MASK;
	wk |= (UARTE3_PM3_INIT & UARTE3_P3_MASK);
	sil_wrh_mem((void *) PM(3), wk);

	/* ե륿쥸Υå */
	sil_wrb_mem((void *) FCLA27CTL1, 0x80);
#elif TARGET_UARTE_PORT == 5

	/* PORT3(UARTE5) */
	/* PMC3  */
	wk = sil_reh_mem((void *) PMC(3));
	wk &= ~UARTE5_P3_MASK;
	wk |= (UARTE5_PMC3_INIT & UARTE5_P3_MASK);
	sil_wrh_mem((void *) PMC(3), wk);

	/* PFC3  */
	wk = sil_reh_mem((void *) PFC(3));
	wk &= ~UARTE5_P3_MASK;
	wk |= (UARTE5_PFC3_INIT & UARTE5_P3_MASK);
	sil_wrh_mem((void *) PFC(3), wk);

	/* PFCE3  */
	wk = sil_reh_mem((void *) PFCE(3));
	wk &= ~UARTE5_P3_MASK;
	wk |= (UARTE5_PFCE3_INIT & UARTE5_P3_MASK);
	sil_wrh_mem((void *) PFCE(3), wk);

	/* PM3  */
	wk = sil_reh_mem((void *) PM(3));
	wk &= ~UARTE5_P3_MASK;
	wk |= (UARTE5_PM3_INIT & UARTE5_P3_MASK);
	sil_wrh_mem((void *) PM(3), wk);

	/* ե륿쥸Υå */
	sil_wrb_mem((void *) FCLA27CTL3, 0x80);
#else
#error
#endif /* TARGET_UARTE_PORT == 3 */
}

/*
 *  åطν
 */
void
target_clock_initialize(void)
{
	uint32	errcnt = 0;
	uint32	pll0clk, pll1clk, pll2clk;

	/* Init SubClock */
	if (EnableSubOSC() != UC_SUCCESS) {
		errcnt++;
	}

	/* Init MainClock */
	if (EnableMainOSC(MHz(MAINOSC_CLOCK)) != UC_SUCCESS) {
		errcnt++;
	}

	/* Init PLL0 */
	if (SetPLL(0, PLL0_CLOCK, &pll0clk) != UC_SUCCESS) {
		errcnt++;
	}

	/* Init PLL1 */
	if (SetPLL(1, PLL1_CLOCK, &pll1clk) != UC_SUCCESS) {
		errcnt++;
	}

	/* Init PLL2 */
	if (SetPLL(2, PLL2_CLOCK, &pll2clk) != UC_SUCCESS) {
		errcnt++;
	}

	set_clock_selection(CKSC_0(0), CSCSTAT_0(0),   PROT_CKSC0, 0x0014); /* CPUCLK PLL0 / 1 = 64MHz */
	set_clock_selection(CKSC_1(14), CSCSTAT_1(14), PROT_CKSC1, 0x001c); /* URTE2-9 PLL1 / 1 = 32MHz */
	set_clock_selection(CKSC_0(6), CSCSTAT_0(6), PROT_CKSC0, 0x001c);   /* TAUA0 PLL1 / 1 = 32MHz */
}

void
target_hardware_initialize(void)
{
	/* ݡȤν */
	target_port_initialize();

	/* åν */
	target_clock_initialize();
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  V850E2¸ν
	 */
	prc_initialize();

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼Υ
	 */
	trace_dump(target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  FL-850/FL4¸νλ
	 */
	prc_terminate();

#ifdef ENABLE_RETURN_MAIN
	kerflg = FALSE;
	except_nest_cnt = 0U;
	nested_lock_os_int_cnt = 0U;
	sus_all_cnt = 0U;
	sus_all_cnt_ctx = 0U;
	sus_os_cnt = 0U;
	sus_os_cnt_ctx = 0U;

	/* åݥ󥿤νmain()θƤӽФ */
	return_main();
#endif /* ENABLE_RETURN_MAIN */

	infinite_loop();
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char8 c)
{
	if (c == '\n') {
		uart_putc('\r');
	}
	uart_putc(c);
}
