/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 7933 2013-10-02 10:59:02Z shigihara $
 */

/*
 *		åȰ¸⥸塼FL-V850E2/PJ4ѡ
 */

#include "kernel_impl.h"
#include "v850e2_gcc/uart.h"
#include "v850e2_gcc/prc_sil.h"
#include "target_sysmod.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ʸν
 */
void
target_fput_str(const char8 *c)
{
	while (*c != '\0') {
		uart_putc(*c);
		c++;
	}
	uart_putc('\n');
}

/*
 * 32bit IO쥸OR񤭹
 */
LOCAL_INLINE void
set_regw_or(uint32 addr, uint32 val)
{
	uint32 tmp;
	tmp = sil_rew_mem((void *) addr);
	tmp |= val;
	sil_wrw_mem((void *) addr, tmp);
}

/*
 * 32bit IO쥸AND񤭹
 */
LOCAL_INLINE void
set_regw_and(uint32 addr, uint32 val)
{
	uint32 tmp;
	tmp = sil_rew_mem((void *) addr);
	tmp &= val;
	sil_wrw_mem((void *) addr, tmp);
}

/*
 *  LEDν
 */
static void
led_initialize(void)
{
	/* IOݡȤȤƻ */
	set_regw_and(PMC4, ~LED_MASK);
	/* ϥݡȤȤ */
	set_regw_and(PM4, ~LED_MASK);
	/*  */
	set_regw_or(P4, LED_MASK);
}

/*
 * LED
 */
void
led_set(uint8 data)
{
	uint32 tmp;
	tmp = sil_rew_mem((void *) P4);
	tmp &= ~LED_MASK;
	tmp |= (~data << LED_SHIFT) & LED_MASK;
	sil_wrw_mem((void *) P4, tmp);
}

/*
 *  ݡȤν
 */
void
target_port_initialize(void)
{
#if TARGET_UARTE_PORT == 2
	/*
	 * UARTE2ΥݡȤν
	 */
	/* P3_10:URTE5TXD P3_9:URTE5RXD */
	sil_wrw_mem((void *) (PMC0),
				sil_rew_mem((void *) (PMC0)) | 0x0060);
	sil_wrw_mem((void *) (PFC0),
				sil_rew_mem((void *) (PFC0)) | 0x0060);
	sil_wrw_mem((void *) (PFCE0),
				sil_rew_mem((void *) (PFCE0)) & 0xff9f);
	sil_wrw_mem((void *) (PM0),
				sil_rew_mem((void *) (PM0)) & 0xffbf);
#else
#error
#endif /* TARGET_UARTE_PORT == 2 */
}

void
target_hardware_initialize(void)
{
	/* ݡȤν */
	target_port_initialize();
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  V850E2¸ν
	 */
	prc_initialize();

	/*
	 *  LEDν
	 */
	led_initialize();

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼Υ
	 */
	trace_dump(target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  FL-850/PJ4¸νλ
	 */
	prc_terminate();

#ifdef ENABLE_RETURN_MAIN
	kerflg = FALSE;
	except_nest_cnt = 0U;
	nested_lock_os_int_cnt = 0U;
	sus_all_cnt = 0U;
	sus_all_cnt_ctx = 0U;
	sus_os_cnt = 0U;
	sus_os_cnt_ctx = 0U;

	/* åݥ󥿤νmain()θƤӽФ */
	return_main();
#endif /* ENABLE_RETURN_MAIN */

	infinite_loop();
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char8 c)
{
	if (c == '\n') {
		uart_putc('\r');
	}
	uart_putc(c);
}
