/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2012-2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2012-2013 by FUJISOFT INCORPORATED, JAPAN
 *  Copyright (C) 2012-2013 by FUJITSU VLSI LIMITED, JAPAN
 *  Copyright (C) 2012-2013 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2012-2013 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2012-2013 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2012-2013 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2012-2013 by Witz Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: hsbv850e2fg4.h 7959 2013-10-10 05:06:00Z fsi-dankei $
 */
/*
 *		HSBV850E2FG4ܡɤ
 */

#ifndef TOPPERS_HSBV850E2FG4_H
#define TOPPERS_HSBV850E2FG4_H

#if !(defined(__f4002__) || defined(__f3577__))
#error Target MCU type is not supported!!
#endif

#define USE_BB_SUTDY_IO

#ifdef __f4002__

/*
 *  uPD70F4002 V8502E/FG4
 */

#define V850FG4

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"HSBV850E2FG4(V850E2/FG4:uPD70F4002)"

/*
 *  å®
 */
#define PCLOCK			(40000000)

/*
 *  PLLϢ
 */
#define MAINOSC_CLOCK	20  /* MainOSC is 20MHz */
#define PLL0_CLOCK		80  /* PLL0 is 80MHz */
#define PLL1_CLOCK		40  /* PLL1 is 40MHz */
#define PLL2_CLOCK		80  /* PLL2 is 80MHz */


/* LED PORT Configuration
     P0_12 : LED1(OUT)
     P0_13 : LED2(OUT)
     P0_14 : LED3(OUT)
     P0_15 : LED4(OUT)
 */
/*
 * LED³Ƥݡ
 */
#define LED_PORT_NO	0

#define LED_PORT_MASK				((uint16) 0xf000)
#define LED_PORT_PMC_INIT			((uint16) 0x0000)
#define LED_PORT_PFCE_INIT			((uint16) 0x0000)
#define LED_PORT_PFC_INIT			((uint16) 0x0000)
#define LED_PORT_PM_INIT			((uint16) 0x0000)
#define LED_PORT_P_INIT				((uint16) 0x0000)

#define LED1_BIT					((uint16) 0x1000)
#define LED2_BIT					((uint16) 0x2000)
#define LED3_BIT					((uint16) 0x4000)
#define LED4_BIT					((uint16) 0x8000)
#define LED_BIT_ALL					((uint16) 0xf000)

/*
 * ѤUARTEΥݡֹ
 */
#define TARGET_UARTE_PORT	10

/*
 *  UARTE10³Ƥݡ
 */
#define UARTE10_PORT_NO	0

/* Port 0 Configration
     P0_8 : URTET10TX
     P0_9 : URTER10RX
 */
#define UARTE10_P_MASK				((uint16) 0x0300)
#define UARTE10_PMC_INIT			((uint16) 0x0300)
#define UARTE10_PFC_INIT			((uint16) 0x0000)
#define UARTE10_PFCE_INIT			((uint16) 0x0000)
#define UARTE10_PM_INIT				((uint16) 0x0200)

#include "v850e2_gcc/v850e2_fx4.h"

#endif /* __f4002__ */

#ifdef __f3577__

/*
 *  UPD70F3577GC V8502E/FG4-L
 */

#define V850FG4_L

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"HSBV850E2FG4L(V850E2/FG4-L:uPD70F3577)"

/*
 *  å®
 */
#define PCLOCK			(48000000)

/*
 *  PLLϢ
 */
#define MAINOSC_CLOCK	20  /* MainOSC is 20MHz */
#define PLL0_CLOCK		48  /* PLL0 is 48MHz */

/*
 * LED³Ƥݡ
 */
#define LED_PORT_NO	0

/* Port 0 Configuration
     P0_12 : LED1(OUT)
     P0_13 : LED2(OUT)
     P4_14 : LED3(OUT)
     P4_15 : LED4(OUT)
 */
#define LED_PORT_MASK				((uint16) 0xf000)
#define LED_PORT_PMC_INIT			((uint16) 0x0000)
#define LED_PORT_PFCE_INIT			((uint16) 0x0000)
#define LED_PORT_PFC_INIT			((uint16) 0x0000)
#define LED_PORT_PM_INIT			((uint16) 0x0000)
#define LED_PORT_P_INIT				((uint16) 0x0000)

#define LED1_BIT					((uint16) 0x1000)
#define LED2_BIT					((uint16) 0x2000)
#define LED3_BIT					((uint16) 0x4000)
#define LED4_BIT					((uint16) 0x8000)
#define LED_BIT_ALL					((uint16) 0xF000)

/*
 * ѤUARTEΥݡֹ
 */
#define TARGET_UARTE_PORT	10

/*
 *  UARTE10³Ƥݡ
 */
#define UARTE10_PORT_NO	0

/* Port 0 Configration
     P0_8 : URTET10TX
     P0_9 : URTER10RX
 */
#define UARTE10_P_MASK				((uint16) 0x0300)
#define UARTE10_PMC_INIT			((uint16) 0x0300)
#define UARTE10_PFC_INIT			((uint16) 0x0000)
#define UARTE10_PFCE_INIT			((uint16) 0x0000)
#define UARTE10_PM_INIT				((uint16) 0x0200)

#include "v850e2_gcc/v850e2_fx4l.h"

#endif /* __f3577__ */

#endif /* TOPPERS_HSBV850E2FG4_H */
