/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2013 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_config.c 7959 2013-10-10 05:06:00Z fsi-dankei $
 */

/*
 *		åȰ¸⥸塼RC-Z-BASE-V850ѡ
 */

#include "kernel_impl.h"
#include "v850e2_gcc/uart.h"
#include "v850e2_gcc/prc_sil.h"
#include "target_sysmod.h"
#ifdef ENABLE_RETURN_MAIN
#include "interrupt.h"
#endif /* ENABLE_RETURN_MAIN */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ʸν
 */
void
target_fput_str(const char8 *c)
{
	while (*c != '\0') {
		uart_putc(*c);
		c++;
	}
	uart_putc('\n');
}

/*
 *  LED
 */
void
led_output(uint8 pattern)
{
	uint16 port_data = 0;

	if (!(pattern & LED_ON)) {
		port_data |= LED_BIT;
	}

	/* Output Port */
	sil_wrh_mem((void *) P(LED_PORT_NO),
				(sil_reh_mem((void *) P(LED_PORT_NO)) & ~LED_PORT_MASK) | port_data);
}

/*
 *  ݡȤν
 */
void
target_port_initialize(void)
{
	uint16 wk;

	/*
	 *  Initialize LED connected port
	 */
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(LED_PORT_NO));
	wk &= ~LED_PORT_MASK;
	wk |= (LED_PORT_PMC_INIT & LED_PORT_MASK);
	sil_wrh_mem((void *) PMC(LED_PORT_NO), wk);

	/* PFCE  */
	wk = sil_reh_mem((void *) PFCE(LED_PORT_NO));
	wk &= ~LED_PORT_MASK;
	wk |= (LED_PORT_PFCE_INIT & LED_PORT_MASK);
	sil_wrh_mem((void *) PFCE(LED_PORT_NO), wk);

	/* PFC  */
	wk = sil_reh_mem((void *) PFC(LED_PORT_NO));
	wk &= ~LED_PORT_MASK;
	wk |= (LED_PORT_PFC_INIT & LED_PORT_MASK);
	sil_wrh_mem((void *) PFC(LED_PORT_NO), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(LED_PORT_NO));
	wk &= ~LED_PORT_MASK;
	wk |= (LED_PORT_PM_INIT & LED_PORT_MASK);
	sil_wrh_mem((void *) PM(LED_PORT_NO), wk);

	/* P4  */
	wk = sil_reh_mem((void *) P(LED_PORT_NO));
	wk &= ~LED_PORT_MASK;
	wk |= (LED_PORT_P_INIT & LED_PORT_MASK);
	sil_wrh_mem((void *) P(LED_PORT_NO), wk);

	/*
	 *  UARTE10ѤΥݡȤν
	 */
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(UARTE10_PORT_NO));
	wk &= ~UARTE10_P_MASK;
	wk |= (UARTE10_PMC_INIT & UARTE10_P_MASK);
	sil_wrh_mem((void *) PMC(UARTE10_PORT_NO), wk);

	/* PFC  */
	wk = sil_reh_mem((void *) PFC(UARTE10_PORT_NO));
	wk &= ~UARTE10_P_MASK;
	wk |= (UARTE10_PFC_INIT & UARTE10_P_MASK);
	sil_wrh_mem((void *) PFC(UARTE10_PORT_NO), wk);

	/* PFCE  */
	wk = sil_reh_mem((void *) PFCE(UARTE10_PORT_NO));
	wk &= ~UARTE10_P_MASK;
	wk |= (UARTE10_PFCE_INIT & UARTE10_P_MASK);
	sil_wrh_mem((void *) PFCE(UARTE10_PORT_NO), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(UARTE10_PORT_NO));
	wk &= ~UARTE10_P_MASK;
	wk |= (UARTE10_PM_INIT & UARTE10_P_MASK);
	sil_wrh_mem((void *) PM(UARTE10_PORT_NO), wk);

	/* ե륿쥸Υå */
	sil_wrb_mem((void *) FCLA7CTL0, 0x80);


	/*
	 *  UARTE3ѤΥݡȤν
	 */
	/* PMC  */
	wk = sil_reh_mem((void *) PMC(UARTE3_PORT_NO));
	wk &= ~UARTE3_P_MASK;
	wk |= (UARTE3_PMC_INIT & UARTE3_P_MASK);
	sil_wrh_mem((void *) PMC(UARTE3_PORT_NO), wk);

	/* PFC  */
	wk = sil_reh_mem((void *) PFC(UARTE3_PORT_NO));
	wk &= ~UARTE3_P_MASK;
	wk |= (UARTE3_PFC_INIT & UARTE3_P_MASK);
	sil_wrh_mem((void *) PFC(UARTE3_PORT_NO), wk);

	/* PFCE  */
	wk = sil_reh_mem((void *) PFCE(UARTE3_PORT_NO));
	wk &= ~UARTE3_P_MASK;
	wk |= (UARTE3_PFCE_INIT & UARTE3_P_MASK);
	sil_wrh_mem((void *) PFCE(UARTE3_PORT_NO), wk);

	/* PM  */
	wk = sil_reh_mem((void *) PM(UARTE3_PORT_NO));
	wk &= ~UARTE3_P_MASK;
	wk |= (UARTE3_PM_INIT & UARTE3_P_MASK);
	sil_wrh_mem((void *) PM(UARTE3_PORT_NO), wk);

	/* ե륿쥸Υå */
	sil_wrb_mem((void *) FCLA27CTL1, 0x80);
}

/*
 *  åطν
 */
void
target_clock_initialize(void)
{
	uint32	errcnt = 0;
	uint32	pll0clk, pll1clk, pll2clk;

	/* Init MainClock */
	if (EnableMainOSC(MHz(MAINOSC_CLOCK)) != UC_SUCCESS) {
		errcnt++;
	}

#ifdef PLL0_CLOCK
	/* Init PLL0 */
	if (SetPLL(0, PLL0_CLOCK, &pll0clk) != UC_SUCCESS) {
		errcnt++;
	}
#endif /* PLL0_CLOCK */

#ifdef PLL1_CLOCK
	/* Init PLL1 */
	if (SetPLL(1, PLL1_CLOCK, &pll1clk) != UC_SUCCESS) {
		errcnt++;
	}
#endif /* PLL1_CLOCK */

#ifdef PLL2_CLOCK
	/* Init PLL2 */
	if (SetPLL(2, PLL2_CLOCK, &pll2clk) != UC_SUCCESS) {
		errcnt++;
	}
#endif /* PLL2_CLOCK */

#ifdef __f3550__
	/* CPUCLK PLL0 / 1 = 80MHz */
	set_clock_selection(CKSC_0(0), CSCSTAT_0(0),   PROT_CKSC0, 0x0014);
	/* URTE10 PLL1 / 2 = 25MHz */
	set_clock_selection(CKSC_0(11), CSCSTAT_0(11), PROT_CKSC0, 0x001d);
	/* URTE3 PLL1 / 2 = 50MHz */
	set_clock_selection(CKSC_1(14), CSCSTAT_1(14), PROT_CKSC1, 0x001d);
	/* TAUA0 PLL1 / 1 = 50MHz */
	set_clock_selection(CKSC_0(6), CSCSTAT_0(6), PROT_CKSC0, 0x001c);
	/* OSTM  PLL1 / 2 = 25MHz */
	set_clock_selection(CKSC_1(12), CSCSTAT_1(12), PROT_CKSC1, 0x001d);
#endif /* __f3550__ */

	/* FCNA0/FCNA1  MainOsc / 1 = 10MHz */
	set_clock_selection(CKSC_1(13), CSCSTAT_1(13), PROT_CKSC1, 0x000c);
}

void
target_hardware_initialize(void)
{
	/* ݡȤν */
	target_port_initialize();

	/* åν */
	target_clock_initialize();

	/* LEDν */
	led_output(LED_OFF);
}

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  V850E2¸ν
	 */
	prc_initialize();

#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼ǽν
	 */
	trace_initialize((uintptr) (TRACE_AUTOSTOP));
#endif /* TOPPERS_ENABLE_TRACE */
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
#ifdef TOPPERS_ENABLE_TRACE
	/*
	 *  ȥ졼Υ
	 */
	trace_dump(target_fput_log);
#endif /* TOPPERS_ENABLE_TRACE */

#ifndef ENABLE_RETURN_MAIN
	/*
	 *  åȥν
	 */
	target_fput_str("Kernel Exit...");
#else
	target_fput_str("Kernel Shutdown...");
#endif /* ENABLE_RETURN_MAIN */

	/*
	 *  RC-Z-BASE-V850¸νλ
	 */
	prc_terminate();

#ifdef ENABLE_RETURN_MAIN
	kerflg = FALSE;
	except_nest_cnt = 0U;
	nested_lock_os_int_cnt = 0U;
	sus_all_cnt = 0U;
	sus_all_cnt_ctx = 0U;
	sus_os_cnt = 0U;
	sus_os_cnt_ctx = 0U;

	/* åݥ󥿤νmain()θƤӽФ */
	return_main();
#endif /* ENABLE_RETURN_MAIN */

	infinite_loop();
}

/*
 *  åȰ¸ʸ
 */
void
target_fput_log(char8 c)
{
	if (c == '\n') {
		uart_putc('\r');
	}
	uart_putc(c);
}
